##
# This module is part of class Drupal_Clusting,
# handles the  stack_name => stack_url  connection
# by means of a json file and the hash @stack.
module Stacks_json
  @@stacks_file = File.join ENV['HOME'], '.drc', '.drstacks.json'

  private
  ##
  # Gives back the last stack_name of the hash/json
  def previous
    name, url = @stacks.to_a.last
    name
  end

  ##
  # Reads the json file into @stacks. 
  # In case of errors, it's quietly set to empty.
  def read_stacks_json
    @stacks = JSON.load File.new @@stacks_file
  rescue SystemCallError # most probably: no such file yet
    @stacks = {}
  end

  ##
  # Writes the hash @stacks into the json file.
  # In case of errors, argumentless functionality won't work.
  def write_stacks_json
    File.open(@@stacks_file, 'w') { |f|
      JSON.dump(@stacks, f)
    }
  rescue SystemCallError
  end

  ##
  # Effectively puts the given stack_name at the end 
  # of both the hash and the .json file.
  def put_at_the_end stack_name
    @stacks.delete stack_name
    @stacks[stack_name] = nil 
    write_stacks_json
  end

end