require 'net/http'

##
#
# A wrapper around Net::HTTP::Post and Get methods.
#
class Netting
  @@Timeout = 4 #sec

  ##
  # A full URL has to be given, starting with http[s]:,
  # ending in the port (if port is not the default)
  def initialize url
    @url = url
  end
  
  ##
  # Sends HTTP POST, data as json
  def post *stuff
    send_req Net::HTTP::Post, *stuff
  end
  
  ##
  # Sends HTTP GET and returns the answer
  def get *stuff
    send_req Net::HTTP::Get, *stuff
  end

  private
  ##
  # Sends either a POST or a GET http message.
  def send_req(req_type, action, data=nil)
    uri = URI(@url + action)
    req = req_type.new(uri, 'Content-Type' => 'application/json')
    req.body = data
    begin
      response = Net::HTTP.start(uri.hostname, uri.port, {open_timeout: @@Timeout}) { |http|
        http.request(req)
      }
      response
    rescue Exception => e
      puts " *** #{e.message}"
    end
  end
end
